<?php

session_start(); if (!$_SESSION['user']) { die('not authorized'); }

require_once "config.php";
require_once "../adam/wrapper.php";
require('tfpdf/tfpdf.php'); 

class PDF_With_HTML extends tFPDF
{
  function __construct()
  {
    parent::__construct();
    // Make sure the paths to font files are correct
    $this->AddFont('DejaVu', '', 'DejaVuSansCondensed.ttf', true);
    $this->AddFont('DejaVu', 'B', 'DejaVuSansCondensed-Bold.ttf', true);
  }

  function WriteHTML($html)
  {
    $html = str_replace("\n", '', $html); 
    $html = str_replace("\r", '', $html); 
    $a = preg_split('/<([^<>]*)>/i', $html, -1, PREG_SPLIT_DELIM_CAPTURE);

    foreach ($a as $i => $e) {
      if ($i % 2 == 0) {
        if (@$this->HREF) {
          $this->PutLink($this->HREF, $e);
        } else {
          $this->Write(5, $e);
        }
      } else {
        if ($e[0] == '/') {
          $this->CloseTag(strtoupper(substr($e, 1)));
        } else {
          $a2 = explode(' ', $e);
          $tag = strtoupper(array_shift($a2));
          $attr = array();
          foreach ($a2 as $v) {
            if (preg_match('/([^=]*)=["\']?([^"\']*)/', $v, $a3))
              $attr[strtoupper($a3[1])] = $a3[2];
          }
          $this->OpenTag($tag, $attr);
        }
      }
    }
  }

  function OpenTag($tag, $attr)
  {
    // if ($tag == 'B')
      // $this->SetStyle('B', true);
    if ($tag == 'A')
      $this->HREF = $attr['HREF'];
    if ($tag == 'BR')
      $this->Ln(5);
  }

  function CloseTag($tag)
  {
    // if ($tag == 'B')
    //   $this->SetStyle('B', false);
    if ($tag == 'A')
      $this->HREF = '';
  }

  function SetStyle($tag, $enable)
  {
    // Change the style
    if($tag == 'B') {
      if($enable) {
        $this->SetFont('DejaVu', 'B', 12);
      } else {
        $this->SetFont('DejaVu', '', 12);
      }
    }
  }

  function PutLink($url, $txt)
  {
    $this->SetTextColor(0, 0, 255);
    $this->SetStyle('U', true);
    $this->Write(5, $txt, $url);
    $this->SetStyle('U', false);
    $this->SetTextColor(0);
  }
}

loadAllCfg();
tryConnect();

$pdf = new PDF_With_HTML('P','mm', 'Letter'); 
// $pdf = new tFPDF('P','mm', 'Letter'); 
$pdf->AddFont('DejaVu', '', 'DejaVuSansCondensed.ttf', true);
$pdf->SetMargins(10,10); 
$pdf->SetAutoPageBreak(true); 
$pdf->SetAuthor('Massimo Peroncelli'); 
$pdf->SetCreator('https://www.autobackoffice.com');
$pdf->AddPage(); 

$id = @mysqli_real_escape_string($conn, $_GET['id']);

$chat = retrieveMessagesFromThread($apiKey, $id);
error_log(print_r($chat, true));
$s = "SELECT * FROM assistants WHERE assistantId=(SELECT assistantId FROM threads WHERE threadId='$id')";
$bot = zbSQLAssoc($s);

if (file_exists('../'.@$bot['assistantId'].'/logo.png')) {
  $pdf->Image('../'.$bot['assistantId'].'/logo.png',10,10,50);
}



$pdf->SetFont('DejaVu', '', 10);

$pdf->SetXY(65, 10);
$pdf->WriteHTML( "<a href='$website{$bot['assistantId']}'>".$website.@$bot['assistantId']."</a><br>");
$pdf->SetXY(65, 15);
$pdf->WriteHTML( "<b>Website:</b> ".@$bot['website']."<br>");
$pdf->SetXY(65, 20);
$pdf->WriteHTML( "<b>Phone:</b> ".@$bot['phone']."<br>");
$pdf->SetXY(65, 25);
$pdf->WriteHTML( "<b>Thread started at: ".date("D, M jS h:iA", $chat['data'][count($chat['data'])-1]['created_at'])."</b><br><br>");

$pdf->SetXY(10, 50);
$pdf->SetFont('DejaVu','',12); 
$pdf->WriteHTML("<b>".$chat['name']."</b><br>");
$pdf->SetFont('DejaVu','',10); 
$pdf->WriteHTML("<i>".$chat['description']."</i><br>");


for($i=count($chat['data'])-1; $i>=0; --$i) {
  $m = $chat['data'][$i];
  $content = $m['content'][0]['text']['value'];
  $content = formatText($content, $bot['showBold'] == 'Y', $bot['highlightWord'], $bot['colorHighlight']);
  if ($m['role'] == 'user') {
    $pdf->WriteHTML("<b>USER:</b> ".$content);
  } else {
    $pdf->WriteHTML("<b>ASSISTANT:</b> ".$content);
  }
  $pdf->WriteHTML("<br>");
}

$pdf->Output();
