<script>
var threadId = 0;
$(function() {
  var typingIndicator = $('<i class="bot-message">').text('Typing');

  // Constants for delays (in milliseconds)
  var wordsPerSecond = <?=$a['wordPerSecond']?>;                // Words per second (you can adjust this value)
  var delayForWord = 1000 / wordsPerSecond;  // Delay per word in milliseconds

  var delayForComma = <?=$a['msForComma']?>;               // 0.1 seconds for commas
  var delayForPunctuation = <?=$a['msForStop']?>;         // 0.2 seconds for periods, newlines, exclamation marks, question marks

  function sendMessage() {
    console.log('sendmessage, threadid=' + threadId);
    var message = $('#chatInput').val();
    if (message.trim() === '') return;
    $('#chatInput').val('');
    $('#sendButton').prop('disabled', true); // Disable the send button

    var messageElement = $('<div class="message user-message">').text(message);
    $('#messages').append(messageElement, typingIndicator);
    scrollToBottom();
    animateTypingIndicator(typingIndicator);

    $.ajax({
      url: 'chatgpt.php?threadId=' + threadId + '&' + Math.random(),
      type: 'POST',
      data: { message: message },
      dataType: 'json',
      success: function(data) {
        if (data.status == 'forbidden') {
          typingIndicator.remove();
          var finalResponseElement = $('<div class="message bot-message">').html(formatText(data.text));
          $('#messages').append(finalResponseElement);
          scrollToBottom();
          $('#sendButton').prop('disabled', false); // Re-enable the send button
        } else {
          threadId = data.threadId;
          checkStatus();
        }
      },
      error: function(xhr, status, error) {
        console.log("Error: " + error); // Log the error message
        console.log("Status: " + status); // Log the status
        console.log("Response: " + xhr.responseText); // Log the full response text
        typingIndicator.text('Error handling message. Please try again.');
        $('#sendButton').prop('disabled', false); // Re-enable the send button on error
      }
    });
  }

  function checkStatus() {
    console.log('checkstatus threadid=' + threadId);
    $.ajax({
      url: 'chatgpt.php?threadId=' + threadId + '&' + Math.random(),
      type: 'POST',
      dataType: 'json',
      success: function(data) {
        if (data.status === 'running') {
          setTimeout(function() {
            threadId = data.threadId;
            console.log('timeout cs, threadid=' + threadId);
            checkStatus();
          }, 2000);
        } else if (data.status === 'ok') {
          threadId = data.threadId;
          typingIndicator.remove();

          // Create the message element but don't set its content yet
          var finalResponseElement = $('<div class="message bot-message">');
          $('#messages').append(finalResponseElement);
          // Don't scroll here

          // Start typing the message word by word
          typeMessage(finalResponseElement, data.text);
        }
      },
      error: function(xhr, status, error) {
        console.log("Error2: " + error); // Log the error message
        console.log("Status2: " + status); // Log the status
        console.log("Response2: " + xhr.responseText); // Log the full response text
        typingIndicator.text('Error handling message. Please try again.');
        $('#sendButton').prop('disabled', false); // Re-enable the send button on error
      }
    });
  }

  function typeMessage(element, text) {
    let index = 0;
    let accumulatedText = '';

    // Split text into tokens (words, spaces, punctuation)
    let tokens = text.match(/([\w'’]+|\s+|[^\w\s])/g);

    function typeNextToken() {
      if (index < tokens.length) {
        let token = tokens[index];
        accumulatedText += token;

        // Apply formatting to the accumulated text
        element.html(formatText(accumulatedText));
        index++;

        // Determine the delay based on the token
        let delay = 0;

        if (/^\s+$/.test(token)) {
          // If token is whitespace, no delay
          delay = 0;
        } else if (token === ',') {
          delay = delayForComma;
        } else if (token === '.' || token === '!' || token === '?' || token === '\n') {
          delay = delayForPunctuation;
        } else {
          // Word
          delay = delayForWord;
        }

        setTimeout(typeNextToken, delay);
        // Don't scroll here
      } else {
        // Typing complete, re-enable the send button
        $('#sendButton').prop('disabled', false);

        // After typing is complete, re-render MathJax
        if (typeof MathJax !== 'undefined') {
          if (MathJax.typesetPromise) {
            // MathJax version 3
            MathJax.typesetPromise([element[0]]).then(() => {
              scrollToBottom(); // Scroll after MathJax rendering
            }).catch((err) => console.log('MathJax typeset error: ' + err.message));
          } else if (MathJax.Hub && MathJax.Hub.Queue) {
            // MathJax version 2
            MathJax.Hub.Queue(
              ["Typeset", MathJax.Hub, element[0]],
              function() {
                scrollToBottom(); // Scroll after MathJax rendering
              }
            );
          }
        } else {
          scrollToBottom(); // If MathJax is not present, scroll immediately
        }
      }
    }

    typeNextToken();
  }

  function scrollToBottom() {
    $('#chatContainer').animate({ scrollTop: $('#chatContainer')[0].scrollHeight }, 'fast');
  }

  function animateTypingIndicator(element) {
    let count = 1;
    let interval = setInterval(function() {
      element.text('Typing' + '.'.repeat(count));
      count = count < 5 ? count + 1 : 1;
    }, 200);
    element.data('interval', interval);
  }

  $('#sendButton').click(sendMessage);
  $('#chatInput').keypress(function(e) {
    if (e.which == 13) { // Enter key pressed
      sendMessage();
      e.preventDefault();
    }
  });
});

function formatText(input) {
  // Transform lines starting with ### into <h2> tags
  let formatted = input.replace(/^###\s*(.*)$/gm, '<span style="font-size:130%; font-weight:bold;">$1</span>');

  // Replace newline characters with <br> tags
  formatted = formatted.replace(/\n/g, '<br>');

  <?php
    if ($a['showBold'] == 'Y') {
  ?>
    // Replace ** with <b> and </b> tags
    formatted = formatted.replace(/\*\*(.*?)\*\*/g, '<b>$1</b>');
  <?php
    }
  ?>  

  <?php
    if ($a['highlightWord'] == 'Y') {
  ?>
    // Style the highlight word in the chosen color
    formatted = formatted.replace(/<?=$a['highlightWord']?>/g, '<span style="color: <?=$a['colorHighlight']?>;"><?=htmlentities($a['highlightWord'])?></span>');
  <?php
    }
  ?>

  // Convert URLs starting with http or https into clickable links that open in a new tab
  formatted = formatted.replace(/(https?:\/\/[^\s<]+)/g, '<a href="$1" target="_blank">$1</a>');

  return formatted;
}

// function formatText(input) {
//   // Transform lines starting with ### into <h2> tags
//   let formatted = input.replace(/^###\s*(.*)$/gm, '<span style="font-size:130%; font-weight:bold;">$1</span>');

//   // Replace newline characters with <br> tags
//   formatted = formatted.replace(/\n/g, '<br>');

//   <?php
//     if ($a['showBold'] == 'Y') {
//   ?>
//     // Replace ** with <b> and </b> tags
//     formatted = formatted.replace(/\*\*(.*?)\*\*/g, '<b>$1</b>');
//   <?php
//     }
//   ?>  

//   <?php
//     if ($a['highlightWord'] == 'Y') {
//   ?>
//     // Style the highlight word in the chosen color
//     formatted = formatted.replace(/<?=$a['highlightWord']?>/g, '<span style="color: <?=$a['colorHighlight']?>;"><?=htmlentities($a['highlightWord'])?></span>');
//   <?php
//     }
//   ?>  

//   return formatted;
// }
</script>
