<script>
var threadId = 0;
$(function() {
  var typingIndicator = $('<i class="bot-message">').text('Typing');
  function sendMessage() {
    console.log('sendmessage, threadid='+threadId)
    var message = $('#chatInput').val();
    if (message.trim() === '') return;
    $('#chatInput').val('');
    $('#sendButton').prop('disabled', true); // Disable the send button

    var messageElement = $('<div class="message user-message">').text(message);
    $('#messages').append(messageElement, typingIndicator);
    scrollToBottom();
    animateTypingIndicator(typingIndicator);

    $.ajax({
      url: 'chatgpt.php?threadId='+threadId+'&'+Math.random(),
      type: 'POST',
      data: { message: message },
      dataType: 'json',
      success: function(data) {
        console.log('success sendmessage, threadid='+threadId)
        threadId = data.threadId
        checkStatus()
      },
      error: function(xhr, status, error) {
        console.log("Error: " + error); // Log the error message
        console.log("Status: " + status); // Log the status
        console.log("Response: " + xhr.responseText); // Log the full response text
        typingIndicator.text('Error handling message. Please try again.');
        $('#sendButton').prop('disabled', false); // Re-enable the send button on error
      }      
    });

  }

  function checkStatus() {
    console.log('checkstatus threadid='+threadId)
    $.ajax({
      url: 'chatgpt.php?threadId='+threadId+'&'+Math.random(),
      type: 'POST',
      dataType: 'json',
      success: function(data) {
        if (data.status === 'running') {
          setTimeout(function() {
            threadId = data.threadId
            console.log('timeout cs, threadid='+threadId)
            checkStatus();
          }, 5000);
        } else if (data.status === 'ok') {
          threadId = data.threadId;
          $('#sendButton').prop('disabled', false); // Re-enable the send button
          typingIndicator.remove();
          var finalResponseElement = $('<div class="message bot-message">').html(formatText(data.text));
          console.log(data.text);
          $('#messages').append(finalResponseElement);
          scrollToBottom();
          // After typing is complete, re-render MathJax
          if (typeof MathJax !== 'undefined') {
            if (MathJax.typesetPromise) {
              // MathJax version 3
              MathJax.typesetPromise([element[0]]).catch((err) => console.log('MathJax typeset error: ' + err.message));
            } else if (MathJax.Hub && MathJax.Hub.Queue) {
              // MathJax version 2
              MathJax.Hub.Queue(["Typeset", MathJax.Hub, element[0]]);
            }
          }
        }
      },
      error: function(xhr, status, error) {
        console.log("Error2: " + error); // Log the error message
        console.log("Status2: " + status); // Log the status
        console.log("Response2: " + xhr.responseText); // Log the full response text
        typingIndicator.text('Error handling message. Please try again.');
        $('#sendButton').prop('disabled', false); // Re-enable the send button on error
      }      
    });
  }

  function scrollToBottom() {
    $('#chatContainer').animate({ scrollTop: $('#chatContainer')[0].scrollHeight }, 'fast');
  }

  function animateTypingIndicator(element) {
    let count = 1;
    let interval = setInterval(function() {
      element.text('Typing' + '.'.repeat(count));
      count = count < 5 ? count + 1 : 1;
    }, 200);
    element.data('interval', interval);
  }

  $('#sendButton').click(sendMessage);
  $('#chatInput').keypress(function(e) {
    if (e.which == 13) { // Enter key pressed
      sendMessage();
      e.preventDefault();
    }
  });
});

function formatText(input) {
  // Replace newline characters with <br> tags
  let formatted = input.replace(/\n/g, '<br>');

<?php
  if ($a['showBold'] == 'Y') {
?>
  // Replace ** with <b> and </b> tags
  formatted = formatted.replace(/\*\*(.*?)\*\*/g, '<b>$1</b>');
<?php
  }
?>  

<?php
  if ($a['highlightWord'] == 'Y') {
?>
  // Style the hightlight word in the chosen color
  formatted = formatted.replace(/<?=$a['highlightWord']?>/g, '<span style="color: <?=$a['colorHighlight']?>;"><?=htmlentities($a['highlightWord'])?></span>');
<?php
  }
?>  
  return formatted;
}
</script>