<?php

require_once "apikey.php";

date_default_timezone_set('America/Los_Angeles');

$currentDirectory = getcwd();
$parentDirectory = dirname($currentDirectory);
$assistantId = basename(getcwd()); // the name of the bot is the folder name!

$SERVER_NAME  = 'LOCALHOST';
$DB_USERNAME  = 'localtha_nathanbot';
$DB_PASSWORD  = 'Na_30672';
$DB_NAME      = 'localtha_nathanbot';

function deleteAssistant($apiKey, $assistantId) {
  $apiUrl = "https://api.openai.com/v1/assistants/$assistantId";

  $ch = curl_init($apiUrl);
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
    'Content-Type: application/json',
    'Authorization: Bearer ' . $apiKey,
    'OpenAI-Beta: assistants=v2'
  ]);
  curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'DELETE');
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  $response = curl_exec($ch);
  if (curl_errno($ch)) {
      echo 'Curl error: ' . curl_error($ch);
  }
  curl_close($ch);

  // Decode the response
  $responseDecoded = json_decode($response, true);
  if (isset($responseDecoded['error'])) {
      echo 'Error: ' . $responseDecoded['error']['message'];
      error_log('Error: ' . $responseDecoded['error']['message']);
      return null;
  } else {
      return $responseDecoded;
  }

}

function deleteThread($apiKey, $threadId) {
  error_log("deleteThread $apiKey / $threadId");
  // Initialize a cURL session
  $curl = curl_init();
  
  // Set the URL and other options for the cURL request
  curl_setopt_array($curl, [
    CURLOPT_URL => "https://api.openai.com/v1/threads/" . $threadId,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_ENCODING => "",
    CURLOPT_MAXREDIRS => 10,
    CURLOPT_TIMEOUT => 30,
    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
    CURLOPT_CUSTOMREQUEST => "DELETE",
    CURLOPT_HTTPHEADER => [
      "Content-Type: application/json",
      "Authorization: Bearer $apiKey",
      "OpenAI-Beta: assistants=v2"
    ],
  ]);
  
  // Execute the cURL session and capture the response
  $response = curl_exec($curl);
  $err = curl_error($curl);
  
  // Close the cURL session
  curl_close($curl);
  
  // Check for errors and print the response
  if ($err) {
    echo "cURL Error #:" . $err;
    error_log("DeleteThread CURL error: $err");
  } else {
    // Decode the response
    $responseDecoded = json_decode($response, true);
    error_log(print_r($responseDecoded, true));
    if (isset($responseDecoded['error'])) {
        echo 'Error: ' . $responseDecoded['error']['message'];
        error_log('Delete Thread Error: ' . $responseDecoded['error']['message']);
        return null;
    } else {
        return $responseDecoded;
    }
  }
}


function createRun($apiKey, $assistantId, $threadId) {
  $apiUrl = "https://api.openai.com/v1/threads/$threadId/runs";

  $data = [
      'assistant_id' => "$assistantId"
  ];

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $apiUrl);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
      'Authorization: Bearer ' . $apiKey,
      'Content-Type: application/json',
      'OpenAI-Beta: assistants=v2'
  ]);

  $response = curl_exec($ch);
  if (curl_errno($ch)) {
      echo 'Curl error: ' . curl_error($ch);
  }
  curl_close($ch);

  // Decode the response
  $responseDecoded = json_decode($response, true);
  if (isset($responseDecoded['error'])) {
      error_log('createrun Error: ' . $responseDecoded['error']['message']);
      return null;
  } else {
      return $responseDecoded;
  }
}
function retrieveMessagesFromThread($apiKey, $threadId) {
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, "https://api.openai.com/v1/threads/$threadId/messages");
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
    'Content-Type: application/json',
    'Authorization: Bearer ' . $apiKey,
    'OpenAI-Beta: assistants=v2'
  ]);

  $response = curl_exec($ch);
  if (curl_errno($ch)) {
      echo 'Curl error: ' . curl_error($ch);
  }
  curl_close($ch);
  return json_decode($response, true);
}


function modifyAssistant($apiKey, $assistantId, $name, $model, $description, $instructions) {
  $apiUrl = "https://api.openai.com/v1/assistants/$assistantId";
  $data = [
    'instructions' => $instructions,
    'name' => $name,
    'description' => $description,
    'model' => $model
  ];
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $apiUrl);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
    'Content-Type: application/json',
    'Authorization: Bearer ' . $apiKey,
    'OpenAI-Beta: assistants=v2'
  ]);

  $response = curl_exec($ch);
  if (curl_errno($ch)) {
      echo 'Curl error: ' . curl_error($ch);
  }
  curl_close($ch);
  return json_decode($response, true);
}

function sendMessageToThread($apiKey, $threadId, $content) {
  $data = [
      'role' => 'user',
      'content' => $content
  ];

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, "https://api.openai.com/v1/threads/$threadId/messages");
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
    'Content-Type: application/json',
    'Authorization: Bearer ' . $apiKey,
    'OpenAI-Beta: assistants=v2'
  ]);

  $response = curl_exec($ch);
  if (curl_errno($ch)) {
      echo 'Curl error: ' . curl_error($ch);
  }
  curl_close($ch);
  return json_decode($response, true);
}

function listRuns($apiKey, $threadId) {
  $apiUrl = "https://api.openai.com/v1/threads/$threadId/runs";

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $apiUrl);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
      'Content-Type: application/json',
      'Authorization: Bearer ' . $apiKey,
      'OpenAI-Beta: assistants=v2'
  ]);
  
  $response = curl_exec($ch);
  if (curl_errno($ch)) {
      echo 'Curl error: ' . curl_error($ch);
  }
  curl_close($ch);
  
  // Decode the response
  $responseDecoded = json_decode($response, true);
  if (isset($responseDecoded['error'])) {
    echo 'Error: ' . $responseDecoded['error']['message'];
    return null;
  } else {
    return $responseDecoded;
  }

}

function listMessages($apiKey, $threadId) {
  $apiUrl = "https://api.openai.com/v1/threads/$threadId/messages";

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $apiUrl);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
      'Content-Type: application/json',
      'Authorization: Bearer ' . $apiKey,
      'OpenAI-Beta: assistants=v2'
  ]);
  
  $response = curl_exec($ch);
  if (curl_errno($ch)) {
      echo 'Curl error: ' . curl_error($ch);
  }
  curl_close($ch);
  
  // Decode the response
  $responseDecoded = json_decode($response, true);
  if (isset($responseDecoded['error'])) {
    echo 'Error: ' . $responseDecoded['error']['message'];
    return null;
  } else {
    return $responseDecoded;
  }
}

function getRun($apiKey, $threadId, $runId) {
  $apiUrl = "https://api.openai.com/v1/threads/$threadId/runs/$runId";
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $apiUrl);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
      'Content-Type: application/json',
      'Authorization: Bearer ' . $apiKey,
      'OpenAI-Beta: assistants=v2'
  ]);

  $response = curl_exec($ch);
  if (curl_errno($ch)) {
      echo 'Curl error: ' . curl_error($ch);
  }
  curl_close($ch);

  // Decode the response
  $responseDecoded = json_decode($response, true);
  if (isset($responseDecoded['error'])) {
      echo 'Error: ' . $responseDecoded['error']['message'];
      return null;
  } else {
      return $responseDecoded;
  }

}

function createThread($apiKey) {
  $apiUrl = 'https://api.openai.com/v1/threads';

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $apiUrl);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
      'Content-Type: application/json',
      'Authorization: Bearer ' . $apiKey,
      'OpenAI-Beta: assistants=v2'
  ]);

  $response = curl_exec($ch);
  if (curl_errno($ch)) {
      echo 'Curl error: ' . curl_error($ch);
  }
  curl_close($ch);

  // Decode the response
  $responseDecoded = json_decode($response, true);
  if (isset($responseDecoded['error'])) {
      echo 'Error: ' . $responseDecoded['error']['message'];
      return null;
  } else {
      return $responseDecoded;
  }

}
  
function listAssistants($apiKey) {
  $url = "https://api.openai.com/v1/assistants?order=desc&limit=20";
  $authorization = "Authorization: Bearer " . $apiKey;
  
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $url);
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
    "Content-Type: application/json",
    $authorization,
    "OpenAI-Beta: assistants=v2"
  ]);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

  $response = curl_exec($ch);
  if (curl_errno($ch)) {
      echo 'Curl error: ' . curl_error($ch);
  }
  curl_close($ch);

  // Decode the response
  $responseDecoded = json_decode($response, true);
  if (isset($responseDecoded['error'])) {
      echo 'Error: ' . $responseDecoded['error']['message'];
      return null;
  } else {
      return $responseDecoded;
  }

}

function getAssistant($apiKey, $assistantId) {
  $apiUrl = "https://api.openai.com/v1/assistants/$assistantId";

  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $apiUrl);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
      'Content-Type: application/json',
      'Authorization: Bearer ' . $apiKey,
      'OpenAI-Beta: assistants=v2'
  ]);

  $response = curl_exec($ch);
  if (curl_errno($ch)) {
      echo 'Curl error: ' . curl_error($ch);
  }
  curl_close($ch);

  // Decode the response
  $responseDecoded = json_decode($response, true);
  if (isset($responseDecoded['error'])) {
      echo 'Error: ' . $responseDecoded['error']['message'];
      return null;
  } else {
      return $responseDecoded;
  }

}

function createAssistant($apiKey, $name, $model='gpt-4o-mini', $description, $instructions) {
  $apiUrl = 'https://api.openai.com/v1/assistants';
  
  $data = [
      'instructions' => $instructions,
      'name' => $name,
      'description' => $description,
      'model' => $model
  ];
  
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, $apiUrl);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  curl_setopt($ch, CURLOPT_POST, 1);
  curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
      'Content-Type: application/json',
      'Authorization: Bearer ' . $apiKey,
      'OpenAI-Beta: assistants=v2'
  ]);
  
  $response = curl_exec($ch);
  if (curl_errno($ch)) {
      echo 'Curl error: ' . curl_error($ch);
  }
  curl_close($ch);
  
  // Decode the response
  $responseDecoded = json_decode($response, true);
  if (isset($responseDecoded['error'])) {
      echo 'Error: ' . $responseDecoded['error']['message'];
      return null;
  } else {
      return $responseDecoded;
  }
}

function d($message) {
  // File to write the debug messages
  $file = 'debug_log.txt';

  // Create or open the file for appending
  $handle = fopen($file, 'a');

  // Generate the timestamp
  $timestamp = date('[Y-m-d H:i:s]');

  // Format the message with a newline at the end
  $logMessage = $timestamp . ' ' . $message . PHP_EOL;

  // Write the formatted message to the file
  fwrite($handle, $logMessage);

  // Close the file handle
  fclose($handle);
}

function getClientIP() {
  if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
    // IP from shared internet
    $ip = $_SERVER['HTTP_CLIENT_IP'];
  } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
    // IP passed from proxy
    $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
  } else {
    // Standard IP address
    $ip = $_SERVER['REMOTE_ADDR'];
  }
  return $ip;
}

function debugFile($f, $s) {
  file_put_contents($f, date('[Y-m-d H:i:s] ') . "$s" . PHP_EOL, FILE_APPEND);
}

if (!function_exists('debug')) {
  function debug($r) {
    echo "<pre>".print_r($r, true)."</pre>";
  }
}

function formatBytes($bytes) {
  if ($bytes >= 1048576) { // If the number is 1MB or larger
    return number_format($bytes / 1048576, 1) . ' MB';
  } else {
    return number_format($bytes / 1024, 1) . ' kB';
  }
}

if (!function_exists("zbSQL")) {
  function zbSQL($s) { global $conn; return mysqli_fetch_row($conn->query($s))[0];}
}

if (!function_exists("zbSQLAssoc")) {
  function zbSQLAssoc($s) { global $conn; $result = $conn->query($s); if ($result) { return $result->fetch_array(MYSQLI_ASSOC); } else { return null; } } 
}
  
if (!function_exists("zbSQLAssocMulti")) {
  function zbSQLAssocMulti($s) { global $conn; $result = $conn->query($s); $multi = []; if ($result) { while ($multi[] = $result->fetch_array(MYSQLI_ASSOC));; } if ($multi) { array_pop($multi); } return $multi; }  
}

function extractTextFromChats($data) {
  $userTexts = [];
  $assistantTexts = [];

  foreach ($data['data'] as $item) {
    $role = $item['role']; // Determine if the message is from a user or assistant
    $text = $item['content'][0]['text']['value']; // Extract the text content

    if ($role === 'user') {
      $userTexts[] = $text; // Add to user array if the role is 'user'
    } elseif ($role === 'assistant') {
      $assistantTexts[] = $text; // Add to assistant array if the role is 'assistant'
    }
  }

  return ['userTexts' => $userTexts, 'assistantTexts' => $assistantTexts];
}

function timeAgo($timestamp) {
  $now = time(); // Current time for the calculation
  $diff = $now - $timestamp; // Difference in seconds

  // Calculate difference in days, months, and years
  $days = floor($diff / 86400); // 86400 seconds in a day
  $months = floor($days / 30); // Approximate month calculation
  $years = floor($days / 365); // Approximate year calculation

  // Determine appropriate message
  if ($days < 30) {
    return "$days days ago";
  } elseif ($months < 12) {
    return "more than $months months ago";
  } elseif ($years == 1) {
    return "more than one year ago";
  } else {
    return "more than $years years ago";
  }
}

function formatText($input, $bold, $word, $color) {
  // Replace newline characters with <br> tags
  $formatted = preg_replace("/\n/", '<br>', $input);

  if ($bold) {
    // Replace ** with <b> and </b> tags
    $formatted = preg_replace("/\*\*(.*?)\*\*/", '<b>$1</b>', $formatted);
  }

  // Style "Nathan Gold" in blue
  if ($word) {
    $word_quoted = preg_quote($word, '/');
    $color = htmlspecialchars($color, ENT_QUOTES, 'UTF-8');
    $formatted = preg_replace("/$word_quoted/", '<span style="color: '.$color.';">'.$word.'</span>', $formatted);
  }
  return $formatted;
}

function sanitizeAndDelete($input) {
  // Sanitize the input to retain only numbers, digits, underscores, and hyphens
  $sanitizedInput = preg_replace('/[^0-9a-zA-Z_\-]/', '', $input);

  // Construct the directory path from the current folder
  $dir = getcwd() . '/' . $sanitizedInput;

  // Call the recursive delete function
  deleteDirectory($dir);
}

function deleteDirectory($dir) {
  if (!file_exists($dir)) {
    return true;
  }

  if (!is_dir($dir)) {
    return unlink($dir);
  }

  foreach (scandir($dir) as $item) {
    if ($item == '.' || $item == '..') {
      continue;
    }

    if (!deleteDirectory($dir . DIRECTORY_SEPARATOR . $item)) {
      return false;
    }
  }

  return rmdir($dir);
}
