<?php
session_start();

require_once "wrapper.php";

$conn = new mysqli($SERVER_NAME, $DB_USERNAME, $DB_PASSWORD, $DB_NAME);
$conn->set_charset('utf8');
mb_internal_encoding("UTF-8");

header('Content-Type: application/json');

$ip = getClientIP();

$threadId = mysqli_real_escape_string($conn, $_GET['threadId']);

retry:
// if no threadid, create a thread and exit in case of an error
$threadId = @zbSQL("SELECT threadId FROM threads WHERE threadId='$threadId'");
if (!$threadId) {
  $r = createThread($apiKey);
  if ($r) {
    $threadId = $r['id'];
    $conn->query("INSERT INTO threads (threadId, assistantId) VALUES ('$threadId', '$assistantId')");
  } else {
    $response['status'] = 'error';
    $response['threadId'] = $threadId;
    $response['text'] = 'Sorry, cannot answer right now, try again (1)';
    echo json_encode($response);
    exit;
  }
}

// just to prevent flooding...
if (strlen(@$_POST['message'])>256) {
  $response['status'] = 'error';
  $response['threadId'] = $threadId;
  $response['text'] = "I am sorry. Your request seems to be too long, please try to summarize it, thank you!";
  echo json_encode($response);
  exit;
}

if (@$_POST['message']) {
  d("[NATHAN] [$ip] User: ".$_POST['message']);

  $forbidden = zbSQLAssocMulti("SELECT * FROM forbiddenWords WHERE assistantId=0 OR assistantId=(SELECT id FROM assistants WHERE assistantId='$assistantId')");
  $uppercaseMessage = strtoupper($_POST['message']);
  error_log("FORBIDDEN: ".print_r($forbidden, true));
  for($i=0; $i<count($forbidden); ++$i) {
    if (strpos($uppercaseMessage, strtoupper($forbidden[$i]['word']))) {
      $response['text'] = '<b style="color:red">'.$forbidden[$i]['answer'].'</b>';
      $response['threadId'] = $threadId;
      exit;
    }
  }

  $r = sendMessageToThread($apiKey, $threadId, $_POST['message']);
  if (!$r) {
    $response['status'] = 'error';
    $response['text'] = 'Sorry cannot answer, try again. (2)';
    $response['threadId'] = $threadId;
    echo json_encode($response);
    exit;
  } else {
    $r = createRun($apiKey, $assistantId, $threadId); 
    if ($r) {
      $runId = $r['id'];
      debugFile("runs.txt", $runId);
      $s = "INSERT INTO runs (runId, threadId, assistantId) VALUES ('$runId', '$threadId', '$assistantId')";
      $conn->query($s);
      $response['status'] = 'running';
      $response['threadId'] = $threadId;
      echo json_encode($response);
      exit;  
    } else {
      $response['status'] = 'error';
      $response['threadId'] = $threadId;
      $response['text'] = 'Sorry, I cannot answer now, retry.';
      echo json_encode($response);
      goto retry;
    }
  }
}

$s = "SELECT runId FROM runs WHERE threadId='$threadId' ORDER BY id DESC LIMIT 1";
$runId = @zbSQL($s);
if ($runId) {
  $r = listMessages($apiKey, $threadId);
  if ($r) {
    if ($r['data'][0]['role'] == 'assistant' && @$r['data'][0]['content'][0]['text']['value']) {
      // we got an answer!
      d('[NATHAN] Assistant: '.$r['data'][0]['content'][0]['text']['value']);
      $response['status'] = 'ok';
      $response['threadId'] = $threadId;
      $response['text'] = $r['data'][0]['content'][0]['text']['value'];  
      // setcookie("run", "", time() - 3600, "/"); // Set expiration to one hour ago
      // try to understand if we can get how much money has been spent...
      $r = getRun($apiKey, $threadId, $runId);
      if ($r) {
        $inputTokens = $r['usage']['prompt_tokens'];
        $outputTokens = $r['usage']['completion_tokens'];
        $costInput = 0.15*$inputTokens;
        $costOutput = 0.6*$outputTokens;
        $cost = $costInput+$costOutput;
        $assistant = zbSQLAssoc("SELECT * FROM assistants WHERE assistantId='$assistantId'");
        $cost *= $assistant['costMultiplier'];
        $s = "UPDATE runs SET inputTokens=$inputTokens, outputTokens=$outputTokens, totalCost=$cost, costInputPer1MToken=0.15, costOutputPer1MToken=0.6 WHERE runId='$runId'";
        $conn->query($s);
        d("Cost: ".($cost/1000000)." [Input/Output: $inputTokens/$outputTokens]");
        $response['text'] = '<b style="color:red">'.sprintf("%.8f",($cost/1000000)).'$</b> ' .$response['text'];
        $response['threadId'] = $threadId;
      } else {
        $response['status'] = 'running';
        $response['threadId'] = $threadId;
      }
      echo json_encode($response);
      exit;
    }
    $response['status'] = 'running';
    $response['threadId'] = $threadId;
    // $response['text'] = print_r($r, true);
    echo json_encode($response);
    exit;
  }  
}

