<?php
$url = "https://www.democoach.com/workshops";
$html = file_get_contents($url);

if (!$html) {
  file_put_contents('debugme.txt', "Failed to retrieve HTML.\n", FILE_APPEND);
}

$doc = new DOMDocument();
libxml_use_internal_errors(true);
if (!$doc->loadHTML($html)) {
  file_put_contents('debugme.txt', "Failed to load HTML into DOMDocument.\n", FILE_APPEND);
}
libxml_clear_errors();

$paragraphs = $doc->getElementsByTagName('p');
$text = '';
$debugText = '';

foreach ($paragraphs as $p) {
  if ($p->hasAttribute('class')) {
    $text .= $p->nodeValue . "\n";
    $debugText .= "Extracted text from <p> with class: " . $p->getAttribute('class') . "\n";
  }
}

file_put_contents('extracted_texts.txt', $text, FILE_APPEND);
file_put_contents('debugme.txt', $debugText, FILE_APPEND);

echo "Texts have been extracted and appended to 'extracted_texts.txt'. Debug information written to 'debugme.txt'.";
?>
